HDU1026 Ignatius and the Princess I(优先队列加记录路径)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1026


思路:


此题与普通的迷宫题差异主要在以下两个方面:


(1).存在monster。所以普通队列得到的答案不一定是整体的最优解。

(2).需要输出路径。


第一点:使用自定义优先级的优先队列即可解决。


第二点:使用结构体(或二维数组)来记录路径。但为了避免被可以通过但明显不是最优解的状态将最优解的路径所覆盖掉,我们需要在覆盖路径是加个条件:


if(a.t<road[b.x][b.y].t){   //如果当前能到达b点的状态a的时间 小于 b点记录的前一个状态的时间少 则转移 
	road[b.x][b.y].x = a.x;
	road[b.x][b.y].y = a.y;
	road[b.x][b.y].t = a.t;
}


另外注意输出路径的顺序,我们是从后往前记录,但需要从前往后的输出。

所以使用队列或者递归输出即可


AC代码:


#include <bits/stdc++.h>
using namespace std;

const int maxn = 105;
const int INF = 1e8;
struct P{
	int x,y;
	int t;
	friend bool operator<(P a,P b){
		return a.t > b.t;
	}
}road[maxn][maxn];
int n,m,maze[maxn][maxn],vis[maxn][maxn];
int sx,sy,gx,gy,tt;
int dx[4]={0,0,1,-1},dy[4]={1,-1,0,0};

bool check(int xx,int yy){
	if(xx<0 || xx>=n || yy<0 || yy>=m || maze[xx][yy] == -1 || vis[xx][yy])
		return true;
	return false;
}

int bfs(void){
	sx = sy = 0;
	gx = n - 1;
	gy = m - 1;
	priority_queue<P> que;
	P a,b;
	a.x = sx;
	a.y = sy;
	a.t = 0;
	vis[a.x][a.y] = 1;
	que.push(a);
	while(que.size()){
		int i,j;
		a = que.top();
		que.pop();
		if(a.x == gx && a.y == gy){
			return a.t;
		}
		for(i=0 ;i<4 ;i++){
			b.x = a.x + dx[i];
			b.y = a.y + dy[i];
			if(check(b.x,b.y)){
				continue;
			}
			b.t = a.t + 1 + maze[b.x][b.y];
			if(a.t<road[b.x][b.y].t){
				road[b.x][b.y].x = a.x;
				road[b.x][b.y].y = a.y;
				road[b.x][b.y].t = a.t;
			}
			vis[b.x][b.y] = 1;
			que.push(b);
		}
	}
	return -1;
}

void output(int xx,int yy){
	if(xx == 0 && yy == 0){
		printf("%ds:(0,0)->",tt++);
		return;
	}
	output(road[xx][yy].x,road[xx][yy].y);
	printf("(%d,%d)\n",xx,yy);
	while(maze[xx][yy]>0){
		printf("%ds:FIGHT AT (%d,%d)\n",tt++,xx,yy);
		maze[xx][yy]--;
	}
	if(!(xx==n-1 && yy==m-1)){
		printf("%ds:(%d,%d)->",tt++,xx,yy);
	}
}

int main(){
	while(scanf("%d%d",&n,&m) != EOF){
		char ch;
		int i,j;
		for(i=0 ;i<n ;i++){
			for(j=0 ;j<m ;j++){
				road[i][j].t = INF;
				vis[i][j] = 0;
				cin >> ch;
				if(ch == 'X')
					maze[i][j] = -1;
				else if(ch == '.')
					maze[i][j] = 0;
				else{
					maze[i][j] = ch - '0';
				}
			}
		}
		int tem = bfs();
		if(tem == -1){
			printf("God please help our poor hero.\n");
		}
		else{
			printf("It takes %d seconds to reach the target position, let me show you the way.\n",tem);
			tt = 1;
			output(n-1,m-1);
		}
		printf("FINISH\n");
	}
	return 0;
}







  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 1
    评论
对于HDU4546问题,还可以使用优先队列(Priority Queue)来解决。以下是使用优先队列的解法思路: 1. 首先,将数组a进行排序,以便后续处理。 2. 创建一个优先队列(最小堆),用于存储组合之和的候选值。 3. 初始化优先队列,将初始情况(即前0个数的组合之和)入队列。 4. 开始从1到n遍历数组a的元素,对于每个元素a[i],将当前队列中的所有候选值取出,分别上a[i],然后再将和的结果作为新的候选值入队列。 5. 重复步骤4直到遍历完所有元素。 6. 当队列的大小超过k时,将队列中的最小值弹出。 7. 最后,队列中的所有候选值之和即为前k小的组合之和。 以下是使用优先队列解决HDU4546问题的代码示例: ```cpp #include <iostream> #include <vector> #include <queue> #include <functional> using namespace std; int main() { int n, k; cin >> n >> k; vector<int> a(n); for (int i = 0; i < n; i++) { cin >> a[i]; } sort(a.begin(), a.end()); // 对数组a进行排序 priority_queue<long long, vector<long long>, greater<long long>> pq; // 最小堆 pq.push(0); // 初始情况,前0个数的组合之和为0 for (int i = 0; i < n; i++) { long long num = pq.top(); // 取出当前队列中的最小值 pq.pop(); for (int j = i + 1; j <= n; j++) { pq.push(num + a[i]); // 将所有和结果作为新的候选值入队列 num += a[i]; } if (pq.size() > k) { pq.pop(); // 当队列大小超过k时,弹出最小值 } } long long sum = 0; while (!pq.empty()) { sum += pq.top(); // 求队列中所有候选值之和 pq.pop(); } cout << sum << endl; return 0; } ``` 使用优先队列的方法可以有效地找到前k小的组合之和,时间复杂度为O(nklog(k))。希望这个解法对你有所帮助!
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值